#ifndef FEMDIRICHLET_H
#define FEMDIRICHLET_H

#include "fem.h"

namespace fem
{

/// Dirichlet boundary condition:
///     a target group and a value to be applied on a given dof

class FEM_API Dirichlet
{
public:
#ifndef SWIG
    Group *group;        ///< target group
    std::string m_dofname; ///< target degree of freedom
    double m_val;          ///< prescribed value
#endif

public:
    Dirichlet(Problem &pbl, std::string const &groupname, std::string const &dof, double val);
    ~Dirichlet();

#ifndef SWIG
    friend FEM_API std::ostream &operator<<(std::ostream &out, Dirichlet const &obj);
#endif
};

} // namespace fem

#endif // FEMDIRICHLET_H
