#ifndef FEMENTITY_H
#define FEMENTITY_H

#include "fem.h"
#include <map>

namespace fem
{

/// a gmsh entity

class FEM_API Entity
{
public:
    int dim;                         ///< dimension 0, 1, 2 or 3
    int tag;                         ///< gmsh id
    std::string name;                ///< name (usually "")
    std::string typ;                 ///< Point, Surface, Plane, Line, Volume, etc.
    std::vector<ElementSet *> esets; ///< maillages (1 maillage = 1 type d'élément)
    std::vector<Group *> groups;     ///< physical groups

public:
    Entity(int _dim, int _tag);
    ~Entity();

    void link_to_groups(std::map<std::pair<int, int>, Group *> const &groups_by_dimtag);

    friend FEM_API std::ostream &operator<<(std::ostream &out, Entity const &obj);
};

} // namespace fem

#endif // FEMENTITY_H
